%define _enable_debug_packages %{nil}
%define debug_package          %{nil}

Name:		ghc
Version:	6.6
Release:	%mkrel 5
Summary:	Glasgow Haskell Compilation system
License:	BSD style
Group:		Development/Other
Source:		http://www.haskell.org/ghc/dist/%{version}/ghc-%{version}-src.tar.bz2
Source1:    http://www.haskell.org/ghc/dist/%{version}/ghc-%{version}-src-extralibs.tar.bz2
# fix installation pat on x86_64
Patch1:		ghc-lib64.patch.bz2
URL:		http://haskell.org/ghc/
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:	gmp-devel, readline-devel, flex, perl, docbook-utils
BuildRequires:	ghc
BuildRequires:	ncurses-devel
#BuildRequires:	libMesaglut-devel
BuildRequires:	gcc
BuildRequires:	haddock >= 0.8
BuildRequires:	happy, alex
#BuildRequires: openal-devel
Requires:	gcc
Epoch:		0
# this is not an error, you need need to link application
Requires: gmp-devel
provides: haskell-compiler
provides: haskell-interactive
BuildRequires: haskell-macros >= 6.0

%description
GHC is a state-of-the-art programming suite for Haskell, a purely
functional programming language.  It includes an optimising compiler
generating good code for a variety of platforms, together with an
interactive system for convenient, quick development.  The
distribution includes space and time profiling facilities, a large
collection of libraries, and support for various language
extensions, including concurrency, exceptions, and foreign language
interfaces (C, C++, etc).

%package -n ghc-prof
Summary:	Profiling libraries for GHC
Group:		Development/Other
Requires:	ghc = %{epoch}:%{version}-%{release}

%description -n ghc-prof
Profiling libraries for Glorious Glasgow Haskell Compilation System
(GHC).  They should be installed when GHC's profiling subsystem is
needed.

%package doc
Summary:        GHC docs
Group:          Development/Other

%description doc
GHC is a state-of-the-art programming suite for Haskell, a purely
functional programming language.  It includes an optimising compiler
generating good code for a variety of platforms, together with an
interactive system for convenient, quick development.  The
distribution includes space and time profiling facilities, a large
collection of libraries, and support for various language
extensions, including concurrency, exceptions, and foreign language
interfaces (C, C++, etc).

%define __spec_install_post /usr/lib/rpm/brp-compress

%prep
%setup -q -b 1 -n ghc-%{version}

%if "%{_lib}" != "lib"
%patch1 
%endif

%build
#%ifarch x86_64
#echo "GhcUnregisterised=YES" > mk/build.mk
#echo "SplitObjs=NO" >> mk/build.mk
#%endif
# disable OpenAL : it breaks build :-(  --disable-openal
./configure --prefix=%{_prefix} --libdir=%{_libdir} --disable-alut

make  CFLAGS="$RPM_OPT_FLAGS"
#make all html

make datadir=$RPM_BUILD_DIR/ghc-%{version} SGMLDocWays="html" install-docs
#make datadir=$RPM_BUILD_ROOT%{_docdir}/ghc-%{version} SGMLDocWays="html" install-docs

%install
rm -rf $RPM_BUILD_ROOT

make prefix=$RPM_BUILD_ROOT%{_prefix} libdir=$RPM_BUILD_ROOT%{_libdir}/ghc-%{version} install

SRC_TOP=$PWD
rm -f rpm-*.files
( cd $RPM_BUILD_ROOT
  find .%{_libdir} \( -type f \( -name '*.p_hi' -o -name '*_p.a' \) -fprint $SRC_TOP/rpm-prof.files \) -o \( -type f -not -name 'package.conf' -fprint $SRC_TOP/rpm-ghc.files \)
  sed -i '/%{_lib}$/d' $SRC_TOP/rpm-ghc.files
)

# make paths absolute (filter "./usr" to "/usr")
perl -pi -e "s|\.%{_prefix}|%{_prefix}|" rpm-*.files

# Haskell Provides, ugly way, we can't trust .cabal
mkdir -p %buildroot%_cabal_pkg_deps_dir
touch %buildroot%_cabal_pkg_deps_dir/{provides,requires}

./utils/ghc-pkg/ghc-pkg -f ./driver/package.conf list --simple-output | \
    grep ghc-%{version} | \
    perl -p -e 's/ *([\w-]*)-([^-, ]*)[, ]*/haskell($1) = $2\n/g' | sort | uniq \
    > %buildroot%_cabal_pkg_deps_dir/provides

%clean
rm -rf $RPM_BUILD_ROOT

%files -f rpm-ghc.files
%defattr(-,root,root,-)
%{_bindir}/*
%dir %{_libdir}/ghc-%{version}
#- TODO move this under /etc or don't flag it as config file
%config %{_libdir}/ghc-%{version}/package.conf
%doc ANNOUNCE LICENSE README
%doc HACKING
%{?_cabal_rpm_files}

%files -n ghc-prof -f rpm-prof.files
%defattr(-,root,root,-)

%files doc
%doc html


%changelog
* Mon Mar 12 2007 Olivier Thauvin <nanardon@mandriva.org> 0:6.6-4mdv2007.1
+ Revision: 141468
- bump release
- rebuild with haskell rpm provides

* Mon Mar 05 2007 Olivier Thauvin <nanardon@mandriva.org> 0:6.6-3mdv2007.1
+ Revision: 132930
- add provide haskell-compiler, haskell-interactive

* Thu Dec 21 2006 Michael Scherer <misc@mandriva.org> 0:6.6-2mdv2007.1
+ Revision: 100890
- bump release
- add ghc extralibs, needed to compile pugs

* Sun Dec 10 2006 Michael Scherer <misc@mandriva.org> 0:6.6-1mdv2007.1
+ Revision: 94556
- update to 6.6
- place docs in %%doc
- clean spec

  + Gaëtan Lehmann <glehmann@mandriva.org>
    - Import ghc



* Sat May 13 2006 Gaetan Lehmann <gaetan.lehmann@jouy.inra.fr> 6.4.2-3mdk
- rebuild manually (iurt seems to be stuck)

* Sat May  6 2006 Gaetan Lehmann <gaetan.lehmann@jouy.inra.fr> 6.4.2-2mdk
- patch1: fix installation path of module on x86_64
- disable alut (build fail on deborah (why ?))

* Sat May  6 2006 Gaetan Lehmann <gaetan.lehmann@jouy.inra.fr> 6.4.2-1mdk
- New release 6.4.2
- build with OpenAL

* Tue Jan 03 2006 Olivier Thauvin <nanardon@mandriva.org> 6.4.1-2mdk
- add Requires on gmp-devel as it is need to link any basic apps

* Tue Sep 27 2005 Gaetan Lehmann <gaetan.lehmann@jouy.inra.fr> 6.4.1-1mdk
- final realease (make ghci work on x86_64!)
- drop ghc version build requirement

* Fri Jul  1 2005 Gaetan Lehmann <gaetan.lehmann@jouy.inra.fr> 6.4.1-0.20050630.1mdk
- 6.4.1 fix lots of issues on x86_64, even if ghci is still not usable
- drop all patches (all merged upstream)
- build docs with haddock 0.7
- fix files listed twice warning
- build with default gcc
- build docs in build section
- use %%configure

* Thu May 26 2005 Gaetan Lehmann <gaetan.lehmann@jouy.inra.fr> 6.4-4mdk
- rebuild with itself
- use gcc 3.3 (can't be built with 4.0)

* Sat May 21 2005 Gaetan Lehmann <gaetan.lehmann@jouy.inra.fr> 6.4-3mdk
- use mkrel
- add missing build requirement
- add patches from fedora
- disable OpenAL
- drop ghc requirement for x86_64 bootstrap

* Tue Mar 15 2005 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 6.4-2mdk
- Rebuild with itself

* Fri Mar 11 2005 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 0:6.4-1mdk
- New version 6.4
- BuildRequire previous ghc for bootstrapping

* Mon Feb 21 2005 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 0:6.2.2-2mdk
- Release for Mandrakelinux
- Don't build docs with haddock for now
- Don't BuildRequires itself for bootstrapping
- Reorganize subpackages

* Fri Jan 21 2005 Jens Petersen <petersen@haskell.org> - 0:6.2.2-2
- add x86_64 port
  - build unregistered and without splitobjs
  - specify libdir to configure and install
- rename ghc-prof to ghcXYZ-prof, which obsoletes ghc-prof

* Mon Dec  6 2004 Jens Petersen <petersen@haskell.org> - 0:6.2.2-1
- move ghc requires to ghcXYZ

* Wed Nov 24 2004 Jens Petersen <petersen@haskell.org> - 0:6.2.2-0.fdr.1
- ghc622
  - provide ghc = %%version
- require gcc, gmp-devel and readline-devel

* Fri Oct 15 2004 Gerard Milmeister <gemi@bluewin.ch> - 0:6.2.2-0.fdr.1
- New Version 6.2.2

* Mon Mar 22 2004 Gerard Milmeister <gemi@bluewin.ch> - 0:6.2.1-0.fdr.1
- New Version 6.2.1

* Tue Dec 16 2003 Gerard Milmeister <gemi@bluewin.ch> - 0:6.2-0.fdr.1
- New Version 6.2

* Tue Dec 16 2003 Gerard Milmeister <gemi@bluewin.ch> - 0:6.0.1-0.fdr.3
- A few minor specfile tweaks

* Mon Dec 15 2003 Gerard Milmeister <gemi@bluewin.ch> - 0:6.0.1-0.fdr.2
- Different file list generation

* Mon Oct 20 2003 Gerard Milmeister <gemi@bluewin.ch> - 0:6.0.1-0.fdr.1
- First Fedora release
- Added generated html docs, so that haddock is not needed

* Wed Sep 26 2001 Manuel Chakravarty
- small changes for 5.04

* Wed Sep 26 2001 Manuel Chakravarty
- split documentation off into a separate package
- adapt to new docbook setup in RH7.1

* Mon Apr 16 2001 Manuel Chakravarty
- revised for 5.00
- also runs autoconf automagically if no ./configure found

* Thu Jun 22 2000 Sven Panne
- removed explicit usage of hslibs/docs, it belongs to ghc/docs/set

* Sun Apr 23 2000 Manuel Chakravarty
- revised for ghc 4.07; added suggestions from Pixel <pixel@mandrakesoft.com>
- added profiling package

* Tue Dec 7 1999 Manuel Chakravarty
- version for use from CVS

* Thu Sep 16 1999 Manuel Chakravarty
- modified for GHC 4.04, patchlevel 1 (no more 62 tuple stuff); minimises use
  of patch files - instead emits a build.mk on-the-fly

* Sat Jul 31 1999 Manuel Chakravarty
- modified for GHC 4.04

* Wed Jun 30 1999 Manuel Chakravarty
- some more improvements from vbzoli

* Fri Feb 26 1999 Manuel Chakravarty
- modified for GHC 4.02

* Thu Dec 24 1998 Zoltan Vorosbaranyi 
- added BuildRoot
- files located in /usr/local/bin, /usr/local/lib moved to /usr/bin, /usr/lib

* Tue Jul 28 1998 Manuel Chakravarty
- original version
